<?php

namespace LWVendor;

/**
 * Concrete comment node class.
 */
class HTMLPurifier_Node_Comment extends HTMLPurifier_Node
{
    /**
     * Character data within comment.
     * @type string
     */
    public $data;
    /**
     * @type bool
     */
    public $is_whitespace = \true;
    /**
     * Transparent constructor.
     *
     * @param string $data String comment data.
     * @param int $line
     * @param int $col
     */
    public function __construct($data, $line = null, $col = null)
    {
        $this->data = $data;
        $this->line = $line;
        $this->col = $col;
    }
    public function toTokenPair()
    {
        return array(new HTMLPurifier_Token_Comment($this->data, $this->line, $this->col), null);
    }
}
/**
 * Concrete comment node class.
 */
\class_alias('LWVendor\\HTMLPurifier_Node_Comment', 'HTMLPurifier_Node_Comment', \false);
