<?php

namespace LWVendor;

/**
 * Validates news (Usenet) as defined by generic RFC 1738
 */
class HTMLPurifier_URIScheme_news extends HTMLPurifier_URIScheme
{
    /**
     * @type bool
     */
    public $browsable = \false;
    /**
     * @type bool
     */
    public $may_omit_host = \true;
    /**
     * @param HTMLPurifier_URI $uri
     * @param HTMLPurifier_Config $config
     * @param HTMLPurifier_Context $context
     * @return bool
     */
    public function doValidate(&$uri, $config, $context)
    {
        $uri->userinfo = null;
        $uri->host = null;
        $uri->port = null;
        $uri->query = null;
        // typecode check needed on path
        return \true;
    }
}
/**
 * Validates news (Usenet) as defined by generic RFC 1738
 */
\class_alias('LWVendor\\HTMLPurifier_URIScheme_news', 'HTMLPurifier_URIScheme_news', \false);
// vim: et sw=4 sts=4
